var setColor = [0, 0, 0, 0];
const cvs = document.querySelector('canvas')
const ctx = cvs.getContext('2d')


function init() {
	/* 初始化画布大小 */
	const img = new Image();
	img.onload = () => {
		/* 画布尺寸等于图片尺寸 */
		cvs.width = img.width;
		cvs.height = img.height;
		ctx.drawImage(img, 0, 0)
	}
	img.src = './ios.png'
	/* 占满这个屏幕---先不用了 */
	// cvs.width = window.innerWidth * devicePixelRatio;
	// cvs.height = window.innerHeight * devicePixelRatio;
}
init();

/* 监听点击canvas */
cvs.addEventListener('click', e => {
	console.log(e);
	/* 获取点击位置 */
	const x = e.offsetX;
	const y = e.offsetY;
	upColor(x,y);
	// 取出点击位置的像素点颜色

})

function upColor(x,y){
	const imgData = ctx.getImageData(0, 0, cvs.width, cvs.height);
	console.log(x, y);
	const clickColor = getColor(x, y, imgData);
	// console.log(Color);
	
	/* 修改颜色 */
	function _changeColor(x, y) {
		/* 如果超出边界停止运行 */
		if (x < 0 || x > cvs.width || y < 0 || y > cvs.height) {
			return;
		}
		const color = getColor(x, y, imgData);
		if (diff(color, clickColor) >= 100) {
			return;
		}
		if (diff(color, setColor) === 0) {
			return;
		}
	
		const i = pointoIndex(x, y);
		/* 设置指定下标颜色 */
		imgData.data.set(setColor, i);
		/* 递归调用 */
		// _changeColor(x + 1, y);
		// _changeColor(x - 1, y);
		// _changeColor(x, y + 1);
		// _changeColor(x, y - 1);
		setTimeout(() => {
			_changeColor(x + 1, y);
		}, 0);
		setTimeout(() => {
			_changeColor(x - 1, y);
		}, 0);
		setTimeout(() => {
			_changeColor(x, y + 1);
		}, 0);
		setTimeout(() => {
			_changeColor(x, y - 1);
		}, 0);
		ctx.putImageData(imgData, 0, 0)
	}
	_changeColor(x, y);
	ctx.putImageData(imgData, 0, 0)
	/* 渲染颜色 */
	console.log('运行完成');
}


/* 获取位置的下标 */
function pointoIndex(x, y) {
	// console.log(x, y);
	return (y * cvs.width + x) * 4;
}

/* 获取指定位置的颜色 */
function getColor(x, y, imgData) {
	const i = pointoIndex(x, y);
	return [
		imgData.data[i],
		imgData.data[i + 1],
		imgData.data[i + 2],
		imgData.data[+3]
	];
}

function diff(color1, color2) {
	return Math.abs(color1[0] - color2[0]) +
		Math.abs(color1[1] - color2[1]) +
		Math.abs(color1[2] - color2[2]) +
		Math.abs(color1[3] - color2[3]);
}



/* 监听颜色选择器 */
function onchangeColor() {
	// 获取input元素  
	var inputElement = document.getElementById('color');
	// 获取input元素的值  
	var inputValue = inputElement.value;
	
	console.log('输入的值：', inputValue,hexToRGBA(inputValue));
	// 
	setColor = hexToRGBA(inputValue);
	// upColor(106,33)
}
/* 辅助函数将16进制颜色值改为RGBA */
function hexToRGBA(hex) {  
  // 确保输入是有效的16进制颜色值  
  if (hex.length === 7 && hex[0] === '#') {  
    // 提取颜色通道的值  
    var r = parseInt(hex.slice(1, 3), 16);  
    var g = parseInt(hex.slice(3, 5), 16);  
    var b = parseInt(hex.slice(5, 7), 16);  
    // var a = parseInt('FF', 16); // 默认透明度为100%  
  
    // 如果颜色值包含四个字符，则提取透明度通道的值  
    if (hex.length === 9 && hex[6] === '#') {  
      a = parseInt(hex.slice(7, 9), 16);  
    }  
  
    // 将颜色通道的值存储在数组中，并返回结果  
	// if(a==255){
		/* 如果255就不返回了 */
		return [r, g, b];
	// }
    // return [r, g, b, a];
  } else {  
    throw new Error('Invalid hex color value');  
  }  
}